Debian Bug report logs - #656947
kfreebsd-kernel-headers: sys/soundcard.h unbuildable headers (conflicting types for `__clock_t')

version graph

Package: kfreebsd-kernel-headers; Maintainer for kfreebsd-kernel-headers is GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>; Source for kfreebsd-kernel-headers is src:kfreebsd-kernel-headers.

Reported by: Maximiliano Curia <maxy@gnuservers.com.ar>

Date: Mon, 23 Jan 2012 03:54:02 UTC

Severity: important

Found in version kfreebsd-kernel-headers/0.65

Fixed in version kfreebsd-kernel-headers/0.67

Done: Robert Millan <rmh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#656947; Package kfreebsd-kernel-headers. (Mon, 23 Jan 2012 03:54:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Maximiliano Curia <maxy@gnuservers.com.ar>:
New Bug report received and forwarded. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Mon, 23 Jan 2012 03:54:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Maximiliano Curia <maxy@gnuservers.com.ar>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: kfreebsd-kernel-headers: sys/soundcard.h unbuildable headers (conflicting types for `__clock_t')
Date: Mon, 23 Jan 2012 00:51:46 -0300
Package: kfreebsd-kernel-headers
Version: 0.65
Severity: important

Hi,

A trivial C file (like the ones used by configure):

#include <sys/soundcard.h>

Fails with:
In file included from /usr/include/machine/_types.h:8:0,
                 from /usr/include/sys/_types.h:33,
                 from /usr/include/machine-i386/endian.h:37,
                 from /usr/include/machine/endian.h:8,
                 from /usr/include/sys/soundcard.h:110,
                 from test.c:1:
/usr/include/machine-i386/_types.h:53:23: error: conflicting types for ‘__clock_t’
/usr/include/i386-kfreebsd-gnu/bits/types.h:145:27: note: previous declaration of ‘__clock_t’ was here
In file included from /usr/include/machine-i386/endian.h:37:0,
                 from /usr/include/machine/endian.h:8,
                 from /usr/include/sys/soundcard.h:110,
                 from test.c:1:
/usr/include/sys/_types.h:106:19: error: conflicting types for ‘clock_t’
/usr/include/time.h:60:19: note: previous declaration of ‘clock_t’ was here

The other files are to be part of libc0.1-dev package version 2.13-24

Thanks,




Reply sent to Robert Millan <rmh@debian.org>:
You have taken responsibility. (Mon, 23 Jan 2012 22:16:53 GMT) Full text and rfc822 format available.

Notification sent to Maximiliano Curia <maxy@gnuservers.com.ar>:
Bug acknowledged by developer. (Mon, 23 Jan 2012 22:16:53 GMT) Full text and rfc822 format available.

Message #10 received at 656947-close@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: 656947-close@bugs.debian.org
Subject: Bug#656947: fixed in kfreebsd-kernel-headers 0.66
Date: Mon, 23 Jan 2012 22:03:23 +0000
Source: kfreebsd-kernel-headers
Source-Version: 0.66

We believe that the bug you reported is fixed in the latest version of
kfreebsd-kernel-headers, which is due to be installed in the Debian FTP archive:

kfreebsd-kernel-headers_0.66.dsc
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.66.dsc
kfreebsd-kernel-headers_0.66.tar.gz
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.66.tar.gz
kfreebsd-kernel-headers_0.66_kfreebsd-amd64.deb
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.66_kfreebsd-amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 656947@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Robert Millan <rmh@debian.org> (supplier of updated kfreebsd-kernel-headers package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 23 Jan 2012 22:23:53 +0100
Source: kfreebsd-kernel-headers
Binary: kfreebsd-kernel-headers
Architecture: source kfreebsd-amd64
Version: 0.66
Distribution: unstable
Urgency: low
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Changed-By: Robert Millan <rmh@debian.org>
Description: 
 kfreebsd-kernel-headers - kernel of FreeBSD headers for development
Closes: 656947
Changes: 
 kfreebsd-kernel-headers (0.66) unstable; urgency=low
 .
   * Redefine clock_t as signed to match with Glibc type.  (Closes: #656947)
   * Cleanup and document type collision fixes, merge them into one patch
     (type_collision.diff), discard unnecessary type removal.
Checksums-Sha1: 
 ca2d38b8378c8a90d5244d3dcbe6f2dc1ad7a2d5 1201 kfreebsd-kernel-headers_0.66.dsc
 16757c96128348b23b9375f9d87ce44a1b8d9a0b 50057 kfreebsd-kernel-headers_0.66.tar.gz
 3db0ec9cc0c83a4b63f5b4ec081b70886758016d 1600218 kfreebsd-kernel-headers_0.66_kfreebsd-amd64.deb
Checksums-Sha256: 
 05fb020cfb007edfde1218cbd2ddd9f006c5321ee86c7ab532729d2a82842a0e 1201 kfreebsd-kernel-headers_0.66.dsc
 3e66b0bf510f72edb9154ddfb81373fa68d3260c5690b32c81ae15cb52191fa4 50057 kfreebsd-kernel-headers_0.66.tar.gz
 0a99839741eff6e7a89ade864d1a8d4331acf70c3d87b71d736357d403672d1b 1600218 kfreebsd-kernel-headers_0.66_kfreebsd-amd64.deb
Files: 
 a201edb55236bbd1ce228dc3de27d84e 1201 kernel standard kfreebsd-kernel-headers_0.66.dsc
 a65b359978c99140e392ed0706287ff0 50057 kernel standard kfreebsd-kernel-headers_0.66.tar.gz
 732c846c93ae7d86be01ed10685e49db 1600218 kernel standard kfreebsd-kernel-headers_0.66_kfreebsd-amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/kFreeBSD)

iEYEARECAAYFAk8d0DYACgkQC19io6rUCv8YTgCdFW6gJgmbECQM9EufGAWQ3i9O
j30AnRjcHcBbgzOohf5otNjjHFCUGiST
=upP1
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#656947; Package kfreebsd-kernel-headers. (Wed, 25 Jan 2012 01:21:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Maximiliano Curia <maxy@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 25 Jan 2012 01:21:10 GMT) Full text and rfc822 format available.

Message #15 received at 656947@bugs.debian.org (full text, mbox):

From: Maximiliano Curia <maxy@debian.org>
To: 656947@bugs.debian.org, control@bugs.debian.org
Subject: Re: Bug#656947 closed by Robert Millan <rmh@debian.org> (Bug#656947: fixed in kfreebsd-kernel-headers 0.66)
Date: Tue, 24 Jan 2012 22:19:33 -0300
[Message part 1 (text/plain, inline)]
notfixed 656947 kfreebsd-kernel-headers/0.66
thank

This bug was closed with the following changelog:

>  kfreebsd-kernel-headers (0.66) unstable; urgency=low
>  .
>    * Redefine clock_t as signed to match with Glibc type.  (Closes: #656947)
>    * Cleanup and document type collision fixes, merge them into one patch
>      (type_collision.diff), discard unnecessary type removal.

The clock_t error was fixed but unfortunately the sys/soundcard.h file is
still problematic:

Building a trivial C file (like the ones used by configure):

----
#include <sys/soundcard.h>
----

Gives a different error now, but the sys/soundcard.h is still unbuildable. The
error compiling the same trivial file as before is:

In file included from /usr/include/machine/_types.h:8:0,
                 from /usr/include/sys/_types.h:33,
                 from /usr/include/machine-i386/endian.h:37,
                 from /usr/include/machine/endian.h:8,
                 from /usr/include/sys/soundcard.h:110,
                 from test.c:2:
/usr/include/machine-i386/_types.h:43:2: error: #error this file needs sys/cdefs.h as a prerequisite
/usr/include/machine-i386/_types.h:96:19: error: conflicting types for ‘__time_t’
/usr/include/i386-kfreebsd-gnu/bits/types.h:149:26: note: previous declaration of ‘__time_t’ was here

If I compile the file with: gcc -I /usr/src/kfreebsd-headers-9.0-1/sys -c test.c
compiles fine.

Just for reference, this ends up in a build error:

https://buildd.debian.org/status/fetch.php?pkg=xawtv&arch=kfreebsd-i386&ver=3.102-1&stamp=1327447884&file=log

As the configure script fails to find a usable soundcard.h.

Thanks,
-- 
"Seek simplicity, and distrust it." -- Whitehead's Rule
Saludos /\/\ /\ >< `/
[signature.asc (application/pgp-signature, inline)]

Bug No longer marked as fixed in versions kfreebsd-kernel-headers/0.66. Request was from Maximiliano Curia <maxy@debian.org> to control@bugs.debian.org. (Wed, 25 Jan 2012 01:21:14 GMT) Full text and rfc822 format available.

Reply sent to Robert Millan <rmh@debian.org>:
You have taken responsibility. (Wed, 25 Jan 2012 21:41:09 GMT) Full text and rfc822 format available.

Notification sent to Maximiliano Curia <maxy@gnuservers.com.ar>:
Bug acknowledged by developer. (Wed, 25 Jan 2012 21:41:12 GMT) Full text and rfc822 format available.

Message #22 received at 656947-close@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: 656947-close@bugs.debian.org
Subject: Bug#656947: fixed in kfreebsd-kernel-headers 0.67
Date: Wed, 25 Jan 2012 21:18:10 +0000
Source: kfreebsd-kernel-headers
Source-Version: 0.67

We believe that the bug you reported is fixed in the latest version of
kfreebsd-kernel-headers, which is due to be installed in the Debian FTP archive:

kfreebsd-kernel-headers_0.67.dsc
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.67.dsc
kfreebsd-kernel-headers_0.67.tar.gz
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.67.tar.gz
kfreebsd-kernel-headers_0.67_kfreebsd-amd64.deb
  to main/k/kfreebsd-kernel-headers/kfreebsd-kernel-headers_0.67_kfreebsd-amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 656947@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Robert Millan <rmh@debian.org> (supplier of updated kfreebsd-kernel-headers package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 25 Jan 2012 22:03:37 +0100
Source: kfreebsd-kernel-headers
Binary: kfreebsd-kernel-headers
Architecture: source kfreebsd-amd64
Version: 0.67
Distribution: unstable
Urgency: low
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Changed-By: Robert Millan <rmh@debian.org>
Description: 
 kfreebsd-kernel-headers - kernel of FreeBSD headers for development
Closes: 656947
Changes: 
 kfreebsd-kernel-headers (0.67) unstable; urgency=low
 .
   * Install geom/raid/*.h.
   * s/time_t/__time_t/ in struct bintime.
   * Fix remaining problems affecting <sys/soundcard.h>.  (Closes: #656947)
     - Check for <sys/cdefs.h> using _SYS_CDEFS_H instead of _SYS_CDEFS_H_.
     - Redefine time_t as "long int" to match with Glibc definition.
Checksums-Sha1: 
 9acef82d5130237fa6d641f12e24918061d30886 1201 kfreebsd-kernel-headers_0.67.dsc
 2324f1c965414e16c60716b601d82cb8d0b74f8e 50286 kfreebsd-kernel-headers_0.67.tar.gz
 3e8dbd84d9778a17be633554790f2e4eb9020973 1602960 kfreebsd-kernel-headers_0.67_kfreebsd-amd64.deb
Checksums-Sha256: 
 fe56cdb92514122fad5f4d0e45a5ec0beb500d5678721b683b13eec66a97c14f 1201 kfreebsd-kernel-headers_0.67.dsc
 1e839f3b987e8d23b7e2fbe68089b2cf389ecc5bdc6fc5e294e59190d2a3699f 50286 kfreebsd-kernel-headers_0.67.tar.gz
 54a565a00cbc34b34812929826df417f79fc0a0a6957a23452e6f4ea41dd4047 1602960 kfreebsd-kernel-headers_0.67_kfreebsd-amd64.deb
Files: 
 38a4a852c49d18caaf5c361b13b597fb 1201 kernel standard kfreebsd-kernel-headers_0.67.dsc
 eab365e53e2e299a34fce6470648c876 50286 kernel standard kfreebsd-kernel-headers_0.67.tar.gz
 4b06cffa54de9ce25447bda3ff92cce9 1602960 kernel standard kfreebsd-kernel-headers_0.67_kfreebsd-amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/kFreeBSD)

iEYEARECAAYFAk8gb5oACgkQC19io6rUCv+Z5wCeJnuf0xFf8DpzkQY0S1NdW64I
uRAAn3ULCUCBdYn2JZ0Ib++NYFg86sXm
=AKoz
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#656947; Package kfreebsd-kernel-headers. (Sat, 28 Jan 2012 03:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 28 Jan 2012 03:39:04 GMT) Full text and rfc822 format available.

Message #27 received at 656947@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Debian Bug Tracking System <owner@bugs.debian.org>
Cc: Robert Millan <rmh@debian.org>, 656947@bugs.debian.org
Subject: Re: Bug#656947: __size_t issue affecting soundcard.h remains
Date: Sat, 28 Jan 2012 03:35:49 +0000
[Message part 1 (text/plain, inline)]
Hi,

I think something is still wrong with soundcard.h or the __size_t
definition, because the GNU C++ compiler does not seem to like it:

$ g++-4.6 /usr/include/sys/soundcard.h
In file included from /usr/include/machine/_types.h:8:0,
                 from /usr/include/sys/_types.h:33,
                 from /usr/include/machine-i386/endian.h:37,
                 from /usr/include/machine/endian.h:8,
                 from /usr/include/sys/soundcard.h:110:
/usr/include/machine-i386/_types.h:94:9: error: declaration does not
declare anything [-fpermissive]

/usr/include/machine-i386/_types.h:94:
typedef	__uint32_t	__size_t;		/* sizeof() */

$ g++ /usr/include/sys/soundcard.h -E | grep segsz -C 2
typedef __int32_t __ptrdiff_t;
typedef __int32_t __register_t;
typedef __int32_t __segsz_t;
typedef __uint32_t ;
typedef __int32_t __ssize_t;


I've observed this bug causing configure to fail during an attempted
build of hamfax;  its conftest is attached.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org
[conftest.cpp (text/x-c++src, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#656947; Package kfreebsd-kernel-headers. (Sat, 28 Jan 2012 04:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 28 Jan 2012 04:30:03 GMT) Full text and rfc822 format available.

Message #32 received at 656947@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: 656947@bugs.debian.org
Cc: Debian Bug Tracking System <owner@bugs.debian.org>, Robert Millan <rmh@debian.org>, debian-gcc@lists.debian.org
Subject: Re: Bug#656947: __size_t issue affecting soundcard.h remains
Date: Sat, 28 Jan 2012 04:27:54 +0000
Hi,

On 28/01/12 03:35, Steven Chamberlain wrote:
> $ g++-4.6 /usr/include/sys/soundcard.h
> In file included from /usr/include/machine/_types.h:8:0,
>                  from /usr/include/sys/_types.h:33,
>                  from /usr/include/machine-i386/endian.h:37,
>                  from /usr/include/machine/endian.h:8,
>                  from /usr/include/sys/soundcard.h:110:
> /usr/include/machine-i386/_types.h:94:9: error: declaration does not
> declare anything [-fpermissive]

> $ g++ /usr/include/sys/soundcard.h -E | grep segsz -C 2
> typedef __int32_t __ptrdiff_t;
> typedef __int32_t __register_t;
> typedef __int32_t __segsz_t;
> typedef __uint32_t ;
> typedef __int32_t __ssize_t;

Found it!

I did 'cpp -dD /usr/include/sys/soundcard.h' which led me to this:

/usr/lib/gcc/i486-kfreebsd-gnu/4.6/include/stddef.h:
> 203 #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
> 204 /* __size_t is a typedef on FreeBSD 5!, must not trash it. */
> 205 #else
> 206 #define __size_t
> 207 #endif

Not sure of the right way to fix it so I've CC'd the Debian GCC Maintainers.

Maybe just like this?  It fixes the issue for me.

--- stddef.h.orig	2012-01-28 04:13:06.000000000 +0000
+++ stddef.h	2012-01-28 04:14:05.000000000 +0000
@@ -200,7 +200,7 @@
 #define ___int_size_t_h
 #define _GCC_SIZE_T
 #define _SIZET_
-#if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
+#if defined (__FreeBSD__) && (__FreeBSD__ >= 5) || (__FreeBSD_kernel__)
 /* __size_t is a typedef on FreeBSD 5!, must not trash it. */
 #else
 #define __size_t


While here, I noticed similar stuff in the same file and wondered if it
may have been causing other problems on kFreeBSD, such as:

> /* On FreeBSD 5, machine/ansi.h does not exist anymore... */
> #if defined (__FreeBSD__) && (__FreeBSD__ >= 5)
> #include <sys/_types.h>
> #endif

Thanks,
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 25 Feb 2012 07:37:29 GMT) Full text and rfc822 format available.

Added indication that bug 656947 blocks 657927 Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Tue, 10 Apr 2012 18:51:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 03:40:11 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.